#!/usr/bin/perl -w
# compares nouns from WN 1.6 and WN 1.7
#

$index17file = "dict/index.sense" ;
$index16file = "$ENV{WNHOME}/dict/index.sense" ;

$index16 = readindex($index16file) ;
$index17 = readindex($index17file) ;


# words that disappear
# senses that disappear
foreach $word (keys %$index16) {
  if (!defined($index17->{$word})) {
    $worderrors{$word} = "NOTIN17";
  }
  else {
    foreach $sense (keys %{ $index16->{$word} }) {
      $senseerrors{$word}{$sense} =  "NOTIN17" if !defined  $index17->{$word}{$sense} ;
    }
  }
}

foreach $word (keys %$index17) {
  if (!defined($index16->{$word})) {
    $worderrors{$word} = "NOTIN16";
  }
  else {
    foreach $sense (keys %{ $index17->{$word} }) {
      $senseerrors{$word}{$sense} =  "NOTIN16" if !defined  $index16->{$word}{$sense} ;
    }
  }
}

foreach $word (sort keys %worderrors) {
  printf "%20s\t%s\n",$word,$worderrors{$word} ;
}

foreach $word (sort keys %senseerrors) {
  foreach $sense (sort keys %{ $senseerrors{$word}}){
    printf "%20s\t%20s\t%s\n",$word,$sense,$senseerrors{$word}{$sense} ;
  }
}

sub readindex ($) {
  my($file)=@_ ;
  my($word,$pos,$sense,$synset) ; 
  my $index = {} ;

  open(I,$file) || die "$! $file\n" ;
  while (<I>) {
    ($sense,$synset) = split ;
    ($word) = split(/:/,$sense) ;
    $index->{$word}{$sense} = $synset ;
  }
  return($index) ;
}


