#!/usr/bin/perl -w
#
# lex2senseno.pl fro WN 1.6
#
# input files:
#    lexnames
#    index.sense
#
# output:
#    lex.senseno
#
#    noun.artifact#car car#1
#    noun.artifact#car1 car#2
#    etc.
#
# NOTE: multiword terms are converted to underscore
#

$wn_dict_path = 'dict' ;

# load lexnames

open(I,"$wn_dict_path/lexnames") or die "Cannot open $wn_dict_path/lexnames\n" ;
while(<I>) {
  chop ;
  ($lexno,$lexname,$pos) = split ;
  $lexname{$lexno} = $lexname ;
}
close(I) ;

# parse index.name and print output

open(I,"$wn_dict_path/index.sense") or die "Cannot open $wn_dict_path/index.sense\n" ;
open(O,">lex.senseno") or die "Cannot open lex.senseno\n" ;
while(<I>) {
  chop ;
  ($lexcode,$synset,$senseno) = split ;

  ($word,$pos,$lexno,$lexsenseno,$adjsat,$adjsatn) = ($lexcode =~ /(.*?)%(.*?):(.*?):(.*?):(.*?):(.*?)$/) ;
  $lexsenseno += 0 ;                                            # 01 converted to 1
  $lexsenseno = "" if (!$lexsenseno) ;                          # when 0 use ""
  if ($pos == 5) {
    $adjsatn+=0 ;
    $adjsatn = "" if !$adjsatn ;
    $lexsenseno=":$adjsat$adjsatn"
  }
  print O "$lexname{$lexno}#$word$lexsenseno $word#$senseno\n" ;
}
close(I) ;
close(O) ;


